// Generated by CoffeeScript 1.7.1
(function() {
  var MAGIC_DATA, fs, _firstBytes;

  fs = require("fs");


  /*
      File magic numbers
      Hex digits: xx = variable
      Ascii digits: . = not an ascii char
   */

  MAGIC_DATA = {
    "png": "89 50 4e 47",
    "jpg": "ff d8 ff e0",
    "gif": "47 49 46 38",
    "bmp": "42 4d",
    "bz": "42 5a",
    "gz": "1f 8b",
    "zip": "50 4b 03 04"
  };

  _firstBytes = function(filePath, cb) {
    return fs.open(filePath, 'r', function(err, fd) {
      var buffer;
      if (err) {
        return cb(err);
      }
      buffer = new Buffer(READ_BUFFER_LENGTH);
      return fs.read(fd, buffer, 0, READ_BUFFER_LENGTH, 0, function(err, num) {
        var fileFirstBytes;
        fileFirstBytes = buffer.toString('hex', 0, num);
        return cb(null, fileFirstBytes);
      });
    });
  };


  /*
      detect file
   */

  exports.is = function(filePath, extension, cb) {
    if (!extension) {
      return cb(new Error("has not extension"));
    }
    return _firstBytes(filePath, function(err, bytes) {
      var shouldStartWith;
      if (err) {
        return cb(err);
      }
      if (extension[0] === ".") {
        extension = extension.substr(1, extension.length - 1);
      }
      shouldStartWith = MAGIC_DATA[extension];
      if (shouldStartWith) {
        return cb(null, bytes.indexOf(shouldStartWith) === 0);
      }
      return cb(null, false);
    });
  };

}).call(this);

//# sourceMappingURL=lib.map
